package main

import (
	"fmt"
	"xg_once_query/cmd"
	dbBase "xg_once_query/dbBase"
	_ "xg_once_query/go-driver-xugusql"

	log "github.com/sirupsen/logrus"
)

func main() {
	log.SetLevel(log.TraceLevel)
	//	log.SetReportCaller(true)
	log.SetFormatter(&log.TextFormatter{
		FullTimestamp:   true,
		TimestampFormat: "2006-01-02 15:04:05",
	})

	db := dbBase.DbInit()
	defer db.Close()
	err := db.Ping()
	if err != nil {
		fmt.Printf("数据库连接失败 connect xugu dbms ... failed\n")
		return
	} else {
		fmt.Printf("数据库连接成功 connect xugu dbms ... ok\n")
	}
	cmd.CmdInit(db)

}
